<?php
  ///////////////////////////////////////////////////
  // Система учёта посещаемости сайта - PowerCounter
  // 2003-2006 (C) IT-студия SoftTime (http://www.softtime.ru)
  // Поддержка: http://www.softtime.ru/forum/
  // Симдянов И.В. (simdyanov@softtime.ru)
  // Левин А.В. (loki_angel@mail.ru)
  // Кузнецов М.В. (kuznetsov@softtime.ru)
  // Голышев С.В. (softtime@softtime.ru)
  ///////////////////////////////////////////////////
  // Выставляем уровень обработки ошибок (http://www.softtime.ru/info/articlephp.php?id_article=23)
  Error_Reporting(E_ALL & ~E_NOTICE); 

// Функция архивации поисковых фраз в суточные таблицы
function archive_num_searchquery($tbl_searchquerys, $tbl_arch_num_searchquery)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data FROM $tbl_searchquerys");
  if (!$dat) exit(mysql_error());
  $arr_date = mysql_fetch_array($dat);
  //Последнее полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y"));
  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate)) FROM $tbl_arch_num_searchquery";
  $arh = mysql_query($query);
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из topcounter.php
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }
  //блок архивации
  if (ceil(($last_day - $last_date)/24/60/60))
  {
    $days = ceil(($last_day-$last_date)/24/60/60);
    for ($i = $days; $i>0; $i--)
    {
      // Вспомогательное условие
      $tmp = "putdate < '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL ".($i-1)." DAY AND
              putdate >= '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL $i DAY";

      // Извлекаем число запросов с Yandex
      $query_num_yandex = "SELECT COUNT(*) FROM $tbl_searchquerys WHERE searches = 'yandex' AND ".$tmp;
      // Извлекаем число запросов с Google
      $query_num_google = "SELECT COUNT(*) FROM $tbl_searchquerys WHERE searches = 'google' AND ".$tmp;
      // Извлекаем число запросов с Rambler
      $query_num_rambler = "SELECT COUNT(*) FROM $tbl_searchquerys WHERE searches = 'rambler' AND ".$tmp;
      // Извлекаем число запросов с Aport
      $query_num_aport = "SELECT COUNT(*) FROM $tbl_searchquerys WHERE searches = 'aport' AND ".$tmp;
      // Извлекаем число запросов с MSN
      $query_num_msn = "SELECT COUNT(*) FROM $tbl_searchquerys WHERE searches = 'msn' AND ".$tmp;
        // Извлекаем число запросов с mail.ru                        //добавлено 02.03.06 Loki
      $query_num_mail = "SELECT COUNT(*) FROM $tbl_searchquerys WHERE searches = 'mail' AND ".$tmp;

      $ynd_num = mysql_query($query_num_yandex);
      if(!$ynd_num) exit("yandex_num ".mysql_error());
      $gog_num = mysql_query($query_num_google);
      if(!$gog_num) exit("google_num ".mysql_error());
      $rbl_num = mysql_query($query_num_rambler);
      if(!$rbl_num) exit("rambler_num ".mysql_error());
      $apt_num = mysql_query($query_num_aport);
      if(!$apt_num) exit("aport_num ".mysql_error());
      $msn_num = mysql_query($query_num_msn);
      if(!$msn_num) exit("msn_num ".mysql_error());
        $mil_num = mysql_query($query_num_mail);                         //добавлено 02.03.06 Loki
      if(!$mil_num) exit("mil_num ".mysql_error());

      // Формируем запрос для ахивации поисковых запросов в таблицу $tbl_arch_num_searchquery
      $number_yandex     = mysql_result($ynd_num, 0);
      $number_google     = mysql_result($gog_num, 0);
      $number_rambler    = mysql_result($rbl_num, 0);
      $number_aport      = mysql_result($apt_num, 0);
      $number_msn        = mysql_result($msn_num, 0);
        $number_mail       = mysql_result($mil_num, 0);                  //добавлено 02.03.06 Loki

      $sql_num_queries[] = "(NULL,
                        '".date("Y-m-d H:i:s",$last_day)."' - INTERVAL ".($i-1)." DAY,
                        $number_yandex,
                        $number_google,
                        $number_rambler,
                        $number_aport,
                        $number_msn,
                                $number_mail)";
    }
    if(!empty($sql_num_queries))
    {
      $query = "INSERT INTO $tbl_arch_num_searchquery VALUES".implode(",", $sql_num_queries);
      if(!mysql_query($query)) exit("search - ".mysql_error());
    }
  }
}


function archive_num_searchquery_week($tbl_arch_num_searchquery, $tbl_arch_num_searchquery_week)
{

  // Получаем дату начала регистрации данных и число прошедших с начала регистрации дней
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data
                      FROM $tbl_arch_num_searchquery");
  if (!$dat) exit("first - ".mysql_error());
  $arr_date = mysql_fetch_array($dat);

  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate_end)) FROM $tbl_arch_num_searchquery_week";
  $arh = mysql_query($query);
  if(!$arh) exit("second - ".mysql_error());
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_arch_searchquery
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }

  //Последней полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y"));
  // Вычисляем сколько недель прошло с даты последней архивации
  $week = floor(($last_day - $last_date)/24/60/60/7); 

  // Если прошло больше недели - архивируем данные
  if ($week > 0)
  {
    // $last_date - дата последней архивации... - смотрим далеко ли до
    // конца недели (воскресенье). Интервал включает данные с Понедельника (1)
    // до воскресенья (0).
    $weekday = date('w',$last_date);
    // Делаем так, чтобы воскресенье было 7, а понедельник 1
    // if($weekday === 0) $weekday = 7;

    // Текущему времени приравниваем начальную точку
    $current_date = $last_date;
    while(floor(($last_day - $current_date)/24/60/60/7))
    {
      // Вспомогательное условие
      $tmp = "putdate > '".date("Y-m-d 23:59:59", $current_date)."' AND
              putdate <= '" .date("Y-m-d 23:59:59", $current_date + 24*3600*(7 - $weekday))."'";

      // Извлекаем число запросов с Yandex        //исправлено 02.03.06 Loki
      $query_number     = "SELECT SUM(number_yandex) AS number_yandex,
                                  SUM(number_google) AS number_google,
                                  SUM(number_rambler) AS number_rambler,
                                  SUM(number_aport) AS number_aport,
                                  SUM(number_msn) AS number_msn,
                                             SUM(number_mail) AS number_mail
                           FROM $tbl_arch_num_searchquery WHERE ".$tmp;

      $arch_num = mysql_query($query_number);
      if(!$arch_num) exit("num - ".mysql_error());
      $number_searchquerys = mysql_fetch_array($arch_num);

      // Формируем запрос для ахивации поисковых запросов в таблицу $tbl_arch_num_searchquery_week
      $number_yandex     = $number_searchquerys['number_yandex'];
      $number_google     = $number_searchquerys['number_google'];
      $number_rambler    = $number_searchquerys['number_rambler'];
      $number_aport      = $number_searchquerys['number_aport'];
      $number_msn        = $number_searchquerys['number_msn'];
        $number_mail       = $number_searchquerys['number_mail'];         //добавлено 02.03.06 Loki
                                      
      $sql_num_queries[] = "(NULL,
                            '".date("Y-m-d 23:59:59", $current_date)."',
                            '".date("Y-m-d 23:59:59", $current_date + 24*3600*(7 - $weekday))."',
                            $number_yandex,
                            $number_google,
                            $number_rambler,
                            $number_aport,
                            $number_msn,
                                     $number_mail)";                //исправлено 02.03.06 Loki

      // Увеличиваем текущее время до следующей недели
      $current_date += (7 - $weekday)*24*3600;
      $weekday = 0; // Далее идут циклы по целой недели
      // echo date("Y-m-d 23:59:59", $current_date)."<br>";
    }

    // Формируем окончательный запрос и выполняем его
    if(!empty($sql_num_queries))
    {
      $query = "INSERT INTO $tbl_arch_num_searchquery_week VALUES".implode(",", $sql_num_queries);
      if(!mysql_query($query)) exit("num - ".mysql_error().$query);
    }
  }
}


// Архивируем поисковые запросы
function archive_num_searchquery_month($tbl_arch_num_searchquery, $tbl_arch_num_searchquery_month)
{
  // Получаем дату начала регистрации данных и число прошедших с начала регистрации дней
  $dat = mysql_query("SELECT UNIX_TIMESTAMP(MIN(putdate)) AS data
                      FROM $tbl_arch_num_searchquery");
  if (!$dat) exit("first - ".mysql_error());
  $arr_date = mysql_fetch_array($dat);

  // получаем последнюю дату архивации
  $query = "SELECT UNIX_TIMESTAMP(MAX(putdate + INTERVAL 1 MONTH)) 
            FROM $tbl_arch_num_searchquery_month";
  $arh = mysql_query($query);
  if(!$arh) exit(mysql_error());
  if(mysql_num_rows($arh) > 0)
  {
    $last_date = mysql_result($arh,0);
  }
  if(empty($last_date))
  {
    if(isset($arr_date['data']))
    {
      // Если запуск первый - берём дату из $tbl_arch_num_searchquery
      $last_date = $arr_date['data'];
    }
    else
    {
      // Иначе берём текущие сутки
      $last_date = time();
    }
  }

  //Последней полный день
  $last_day = mktime(23,59,59, date("m"), date("d")-1, date("Y")) + 2;
  // Вычисляем сколько полных месяцев прошло с даты последней архивации
  $month = (floor(date("Y",$last_day) - date("Y",$last_date)))*12 + 
           floor(date("m",$last_day) - date("m",$last_date)); 

  // Если прошло больше месяца - архивируем данные
  if ($month > 0)
  {
    // Архивируем данные по всем месяцам, по которым архивация
    // не проводилась
    for($i = date("Y",$last_date)*12 + date("m",$last_date); $i < date("Y",$last_day)*12 + date("m",$last_day); $i++)
    {
      $year = (int)($i/12);
      $month = ($i%12);
      if($month == 0)
      {
        $year--;
        $month = 12;
      }
      // Вспомогательное условие
      $tmp = "YEAR(putdate) = $year AND
              MONTH(putdate) = '".sprintf("%02d",$month)."'";

      // Извлекаем число запросов
      $query_number     = "SELECT SUM(number_yandex) AS number_yandex,
                                  SUM(number_google) AS number_google,
                                  SUM(number_rambler) AS number_rambler,
                                  SUM(number_aport) AS number_aport,
                                  SUM(number_msn) AS number_msn,
                                             SUM(number_mail) AS number_mail
                           FROM $tbl_arch_num_searchquery WHERE ".$tmp;     //исправлено 02.03.06 Loki

      $arch_num = mysql_query($query_number);
      if(!$arch_num) exit("num - ".mysql_error());
      $number_searchquerys = mysql_fetch_array($arch_num);

      // Формируем запрос для ахивации поисковых запросов в таблицу $tbl_arch_num_searchquery_month
      $number_yandex     = $number_searchquerys['number_yandex'];
      $number_google     = $number_searchquerys['number_google'];
      $number_rambler    = $number_searchquerys['number_rambler'];
      $number_aport      = $number_searchquerys['number_aport'];
      $number_msn        = $number_searchquerys['number_msn'];
        $number_mail       = $number_searchquerys['number_mail'];        //исправлено 02.03.06 Loki

      $sql_num_queries[] = "(NULL,
                           '$year-".sprintf("%02d",$month)."-01 23:59:59',
                            $number_yandex,
                            $number_google,
                            $number_rambler,
                            $number_aport,
                            $number_msn,
                                     $number_mail)";                                    //исправлено 02.03.06 Loki
    }

    // Формируем окончательный запрос и выполняем его
    if(!empty($sql_num_queries))
    {
      $query = "INSERT INTO $tbl_arch_num_searchquery_month VALUES".implode(",", $sql_num_queries);
      if(!mysql_query($query)) exit(mysql_error());
    }
  }
}
?>
